"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @since 0.1.27
 */
var R = __importStar(require("fp-ts/lib/Reader"));
var RT = __importStar(require("fp-ts/lib/ReaderTask"));
var T = __importStar(require("fp-ts/lib/Task"));
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 0.1.27
 */
// TODO use NaturalTransformation<RIO.URI, RT.URI> when fp-ts version >= 2.11.0
exports.fromReaderIO = R.map(T.fromIO);
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 0.1.27
 */
exports.fromReaderIOK = function (f) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return exports.fromReaderIO(f.apply(void 0, a));
}; };
/**
 * Less strict version of [`chainReaderIOK`](#chainreaderiok).
 *
 * @category combinators
 * @since 0.1.27
 */
exports.chainReaderIOKW = function (f) { return RT.chainW(exports.fromReaderIOK(f)); };
/**
 * @category combinators
 * @since 0.1.27
 */
exports.chainReaderIOK = exports.chainReaderIOKW;
/**
 * Less strict version of [`chainFirstReaderIOK`](#chainfirstreaderiok).
 *
 * @category combinators
 * @since 0.1.27
 */
// TODO use RT.chainFirstW when fp-ts version >= 2.11.0
exports.chainFirstReaderIOKW = function (f) { return RT.chainFirst(exports.fromReaderIOK(f)); };
/**
 * @category combinators
 * @since 0.1.27
 */
exports.chainFirstReaderIOK = exports.chainFirstReaderIOKW;
