"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @since 0.1.27
 */
var function_1 = require("fp-ts/lib/function");
var RTE = __importStar(require("fp-ts/lib/ReaderTaskEither"));
var TE = __importStar(require("fp-ts/lib/TaskEither"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 0.1.27
 */
exports.leftReaderIO = function (me) {
    return function_1.flow(me, TE.leftIO);
};
/**
 * @category constructors
 * @since 0.1.27
 */
exports.rightReaderIO = function (ma) {
    return function_1.flow(ma, TE.rightIO);
};
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 0.1.27
 */
exports.fromReaderIOK = function (f) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return exports.rightReaderIO(f.apply(void 0, a));
}; };
/**
 * Less strict version of [`chainReaderIOK`](#chainreaderiok).
 *
 * @category combinators
 * @since 0.1.27
 */
exports.chainReaderIOKW = function (f) {
    return RTE.chainW(exports.fromReaderIOK(f));
};
/**
 * @category combinators
 * @since 0.1.27
 */
exports.chainReaderIOK = exports.chainReaderIOKW;
/**
 * Less strict version of [`chainFirstReaderIOK`](#chainfirstreaderiok).
 *
 * @category combinators
 * @since 0.1.27
 */
exports.chainFirstReaderIOKW = function (f) {
    return RTE.chainFirstW(exports.fromReaderIOK(f));
};
/**
 * @category combinators
 * @since 0.1.27
 */
exports.chainFirstReaderIOK = exports.chainFirstReaderIOKW;
